#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3100five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 3100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five31004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five31004xi = {
                1: '-1022x2007y2129z',
                2: '-1048x854y2789z',
                3: '-1082x1821y2262z',
                4: '-1088x2724y1002z',
                5: '-1114x814y2775z',
                6: '-1137x1969y2106z',
                7: '-1178x770y2761z',
                8: '-1188x1781y2241z',
                9: '-1233x2672y973z',
                10: '-1240x721y2747z',
                11: '-1250x1924y2083z',
                12: '-1293x1734y2220z',
                13: '-1301x668y2733z',
                14: '-130x21y3097z',
                15: '-1359x610y2718z',
                16: '-1361x1873y2060z',
                17: '-1376x2612y943z',
                18: '-1396x1681y2198z',
                19: '-1414x548y2703z',
                20: '-145x938y2950z',
                21: '-1467x481y2687z',
                22: '-1470x1815y2037z',
                23: '-1497x1622y2176z',
                24: '-1515x2545y914z',
                25: '-1516x411y2672z',
                26: '-1561x337y2656z',
                27: '-1576x1751y2014z',
                28: '-1595x1556y2154z',
                29: '-1603x259y2640z',
                30: '-161x17y3095z',
                31: '-1640x177y2624z',
                32: '-1651x2469y884z',
                33: '-1674x93y2607z',
                34: '-1680x1680y1990z',
                35: '-1691x1485y2131z',
                36: '-1702x5y2590z',
                37: '-1780x1603y1966z',
                38: '-1783x1407y2109z',
                39: '-1784x2386y854z',
                40: '-1871x1324y2086z',
                41: '-1877x1520y1942z',
                42: '-1911x2296y824z',
                43: '-193x11y3093z',
                44: '-1955x1235y2063z',
                45: '-1970x1431y1918z',
                46: '-200x958y2941z',
                47: '-2034x2199y794z',
                48: '-2035x1141y2040z',
                49: '-2058x1336y1893z',
                50: '-2110x1042y2016z',
                51: '-2141x1236y1869z',
                52: '-2152x2095y764z',
                53: '-2180x938y1992z',
                54: '-219x2087y2281z',
                55: '-2220x1131y1844z',
                56: '-2245x830y1969z',
                57: '-224x1y3091z',
                58: '-2265x1984y734z',
                59: '-2292x1020y1819z',
                60: '-2304x717y1945z',
                61: '-2357x600y1920z',
                62: '-2360x905y1794z',
                63: '-2371x1867y704z',
                64: '-2404x480y1896z',
                65: '-2421x786y1768z',
                66: '-2445x356y1871z',
                67: '-2471x1745y674z',
                68: '-2476x663y1743z',
                69: '-2479x229y1846z',
                70: '-2524x536y1717z',
                71: '-2565x1616y644z',
                72: '-2565x406y1691z',
                73: '-2586x103y1880z',
                74: '-258x975y2931z',
                75: '-2600x273y1665z',
                76: '-2627x137y1639z',
                77: '-2647x0y1612z',
                78: '-2651x1483y613z',
                79: '-2731x1345y583z',
                80: '-2803x1202y552z',
                81: '-2867x1056y522z',
                82: '-2923x906y491z',
                83: '-2971x753y461z',
                84: '-3011x597y430z',
                85: '-3042x439y399z',
                86: '-3065x280y368z',
                87: '-3079x119y338z',
                88: '-317x988y2921z',
                89: '-329x1927y2405z',
                90: '-331x2095y2260z',
                91: '-339x2859y1147z',
                92: '-36x12y3099z',
                93: '-379x997y2910z',
                94: '-435x1930y2385z',
                95: '-442x1002y2899z',
                96: '-445x2096y2239z',
                97: '-490x2849y1119z',
                98: '-507x1004y2888z',
                99: '-542x1928y2365z',
                100: '-560x2092y2217z',
                101: '-573x1001y2877z',
                102: '-641x2830y1090z',
                103: '-641x994y2865z',
                104: '-650x1919y2345z',
                105: '-676x2080y2195z',
                106: '-67x18y3099z',
                107: '-708x982y2853z',
                108: '-758x1904y2325z',
                109: '-777x966y2841z',
                110: '-791x2063y2173z',
                111: '-791x2803y1060z',
                112: '-7x2y3099z',
                113: '-845x945y2828z',
                114: '-866x1883y2304z',
                115: '-907x2038y2151z',
                116: '-913x919y2815z',
                117: '-93x915y2960z',
                118: '-940x2767y1031z',
                119: '-974x1855y2283z',
                120: '-981x889y2802z',
                121: '-98x21y3098z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3100five4xi" usage = "target function for charge31004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire3100five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3100FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3100FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3100FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3100FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3100FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five31004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3100FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3100FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3100FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five31004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five31004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3100FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3100FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3100FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3100five4xi.py                             
# -------------------------------------------------------------------------------------------------                